`cem.imbalance` <-
function(obj, data, verbose = 0){

	vnames <- obj$vars
	nv <- length(vnames)
	strata <- obj$strata
	st.names <- as.numeric(na.omit(unique(strata)))
	imb1 <- numeric(nv)
	imb2 <- numeric(nv)
	nt <- 0
	for(st in st.names){
	 idx <- which(strata==st)	 
	 c.idx <- idx[which(obj$groups[idx]==obj$g.names[1])]
	 t.idx <- idx[which(obj$groups[idx]==obj$g.names[2])]
	 nt.m <- length(t.idx)
	 if(length(c.idx)>0 && nt.m>0){
      tmp1 <- numeric(nv)
	  for(i in 1:nv){
	  nm <- vnames[i]
	  if(!is.integer(data[[nm]]) && !is.numeric(data[[nm]])){
		if(verbose>1){
 		 cat(sprintf("\nfactor:%s\n",nm))
         print(chisq.test(data[[nm]][t.idx], data[[nm]][c.idx])$statistic)
		}
		tmp1[i] <- 0
	  } else {
		tmp1[i] <- abs(mean(data[[nm]][t.idx]) - mean(data[[nm]][c.idx]))	
	  }
     }
	 imb1 <- imb1 + tmp1*nt.m
	 nt <- nt + nt.m
	}
	}
    imb1 <- imb1/nt
	names(imb1) <- vnames
	if(verbose>1){
	 cat(sprintf("\n*** Group:%s vs Group:%s ***\nAverage absolute imbalance (distance: mean/chisq):\n\n",obj$g.names[1], obj$g.names[2]))
	 print(imb1)
	}
	return(invisible(imb1))
}

