`multicem` <-
function (treatment=NULL, datalist, data = NULL, cutpoints = NULL,  drop=NULL, 
    eval.imbalance = FALSE, k2k=FALSE,  method=NULL, mpower=2, verbose = 0)
{
   if (is.null(datalist)) 
	 stop("Specify at list `data' argument", call. = FALSE)
    if (is.data.frame(datalist)) {
        stop("Please specify a list of data frames", call. = FALSE)
    }
    if (!is.list(datalist)) {
        stop("Please specify a list of data frames", call. = FALSE)
    }

   nd <- length(datalist)
   list.obj <- vector(nd, mode="list")

   if(!is.null(data)){
	n <- dim(data)[1]
    multi.strata <- matrix(NA, n, nd)
        	
    tmp <- na.omit(data)
    comp <- match(rownames(tmp), rownames(data))
	mis <- 1:dim(data)[1] 
	mis <- mis[-comp]
	n.mis <- length(mis)
    n.comp <- length(comp)
	bigdata <- NULL
	
	for(i in 1:nd)
	   bigdata <- rbind(bigdata, datalist[[i]])

    rownames(bigdata) <- 1:(dim(bigdata)[1])
	mat <- cem(treatment=treatment, data=bigdata, cutpoints = cutpoints,  drop=drop, 
               eval.imbalance = eval.imbalance, k2k=k2k, method=method, mpower=mpower, 
			   verbose = verbose)
	
	for(i in 1:nd){
     all <- c(1:n + (i-1)*n )
	 multi.strata[,i] <- mat$strata[all]
    }
	g <- function(x){
	 tmp <- table(x)
	 id <- as.integer(which.max(tmp))
	 names(tmp)[id]
	}
	
#	new.strata <- apply(multi.strata, 1, function(x) as.numeric(names(which.max(table(x)))))
	new.strata <- as.integer(apply(multi.strata, 1, g))

    for(i in 1:nd){
     obj <- mat
	 all <- c(1:n + (i-1)*n )
    obj$X <- mat$X[all,]
	obj$strata <- new.strata
    obj$drop <- drop
    obj$breaks <- mat$breaks
    imbalance <- NULL
    tab <- NULL
    obj$treatment <- treatment
    obj$n <- n
    if (!is.null(treatment)) {
        obj$groups <- mat$groups[all]
        obj$g.names <- levels(obj$groups)
        obj$n.groups <- length(obj$g.names)
        obj$group.idx <- sapply(obj$g.names, function(x) which(obj$groups == 
            x))
        names(obj$group.idx) <- paste("G", obj$g.names, sep = "")
        obj$group.len <- unlist(lapply(obj$group.idx, length))
        tmp <- find.strata(obj)
        obj$mstrata <- tmp$mstrata
        obj$mstrataID <- tmp$mstrataID
        obj$matched <- !is.na(obj$mstrata)
    }
    if (!is.null(treatment)) 
        tab <- cem.summary(obj = obj, verbose = verbose)
    if (eval.imbalance) 
        imbalance <- cem.imbalance(obj, datalist[[i]], verbose = verbose)
    obj$tab <- tab
    obj$imbalance <- imbalance
    obj$k2k <- k2k
    obj$w <- cem.weights(obj)
    class(obj) <- "cem.match"
    if (k2k) 
        obj <- k2k(obj, datalist[[i]], method = method, mpower = mpower, 
            verbose = verbose)

	 list.obj[[i]] <- obj
    }
   
   } else {	
   for(i in 1:nd){
    list.obj[[i]] <- cem(treatment=treatment, data=datalist[[i]], cutpoints = cutpoints,  drop=drop, 
    eval.imbalance = eval.imbalance, k2k=k2k, method=method, mpower=mpower, verbose = verbose)
   }
  

  }
  
   names(list.obj) <- sprintf("match%d",1:nd)
   class(list.obj) <- c("multicem", "list")
 
  return(invisible(list.obj))
}



