\name{L1.meas}
\alias{L1.meas}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Evaluates L1 distance between multidimensional histograms}
\description{
Evaluates L1 distance between multidimensional histograms
}
\usage{
L1.meas(group, data, breaks = NULL, weights)
}
\arguments{
  \item{group}{the group variable}
  \item{data}{the data}
  \item{breaks}{a list of vectors of cutpoints; if not specified,
  automatic choice will be made}
  \item{weights}{weights}
}
\details{
This function calculates the L1 distance on the k-dimensional histogram.

If the \code{breaks} are not specified, the same approach as in
\code{\link{cem}} is used.  Please refer to \code{\link{cem}} help
page. In this case, breaks are used to calculate the L1 measure.

}
\value{
  \item{value}{the L1 measure}
}
\references{Stefano Iacus, Gary King, Giusseppe Porro, ``Matching for
  Casual Inference Without Balance Checking,''
  http://gking.harvard.edu/files/abs/cem-abs.shtml}
\author{Stefano Iacus, Gary King, and Giusseppe Porro}
\examples{
data(LL)
L1.meas(LL$treated,LL[,-c(1,9)])
}
\keyword{ datagen }
